Exiv2: Exiv2::DataValue Class Reference

# Exiv2::DataValue Class Reference

Value for an undefined data type. More...

`#include <value.hpp>`

Inheritance diagram for Exiv2::DataValue:
[legend]
Collaboration diagram for Exiv2::DataValue:
[legend]

List of all members.

## Public Types
typedef std::auto_ptr< DataValue > | AutoPtr
| Shortcut for a DataValue auto pointer.
typedef std::vector< byte > | ValueType
| Type used to store the data.
## Public Member Functions
Creators
| DataValue (TypeId typeId=undefined)
| Default constructor.
| DataValue (const byte *buf, long len, ByteOrder byteOrder=invalidByteOrder, TypeId typeId=undefined)
| Constructor.
virtual | ~DataValue ()
| Virtual destructor.
Manipulators
virtual int | read (const byte *buf, long len, ByteOrder byteOrder=invalidByteOrder)
| Read the value from a character buffer.
virtual int | read (const std::string &buf)
| Set the data from a string of integer values (e.g., "0 1 2 3").
Accessors
AutoPtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy). The caller owns this copy and the auto-pointer ensures that it will be deleted.
virtual long | copy (byte *buf, ByteOrder byteOrder=invalidByteOrder) const
| Write value to a character data buffer.
virtual long | count () const
| Return the number of components of the value.
virtual long | size () const
| Return the size of the value in bytes.
virtual std::ostream & | write (std::ostream &os) const
| Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).
virtual std::string | toString (long n) const
| Return the n-th component of the value as a string. The behaviour of this method may be undefined if there is no n-th component.
virtual long | toLong (long n=0) const
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.
virtual float | toFloat (long n=0) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
virtual Rational | toRational (long n=0) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
## Public Attributes
ValueType | value_
| Stores the data value.

## Detailed Description

Value for an undefined data type.

## Member Function Documentation

virtual int Exiv2::DataValue::read | ( | const byte * | buf,
|  | long | len,
|  | ByteOrder | byteOrder = `invalidByteOrder` |
| ) |  |  | `[virtual]`

Read the value from a character buffer.

Note:
  The byte order is required by the interface but not used by this method, so just use the default.

Parameters:

  | buf | Pointer to the data buffer to read from
  | len | Number of bytes in the data buffer
  | byteOrder | Byte order. Not needed.

Returns:
  0 if successful.

Implements Exiv2::Value.

Referenced by DataValue().

virtual long Exiv2::DataValue::copy | ( | byte * | buf,
|  | ByteOrder | byteOrder = `invalidByteOrder` |
| ) |  |  | const`[virtual]`

Write value to a character data buffer.

Note:
  The byte order is required by the interface but not used by this method, so just use the default.

The user must ensure that the buffer has enough memory. Otherwise the call results in undefined behaviour.

Parameters:

  | buf | Data buffer to write to.
  | byteOrder | Byte order. Not needed.

Returns:
  Number of characters written.

Implements Exiv2::Value.

virtual long Exiv2::DataValue::toLong | ( | long | n = `0` | ) | const`[virtual]`

Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

virtual float Exiv2::DataValue::toFloat | ( | long | n = `0` | ) | const`[virtual]`

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

virtual Rational Exiv2::DataValue::toRational | ( | long | n = `0` | ) | const`[virtual]`

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

The documentation for this class was generated from the following file:

- value.hpp